<template>
  <div>
    <div class="titSec">Búsqueda de Sucursal</div>
    <v-card>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3"></v-col>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <ListaCecoComponente
              v-model="value"
              :callback="callbackCecoSeleccionadoComponent"
              :borrarDatos="borradoPorNivelComponent"
              ref="listaCecoComponente"
            />
          </v-col>
          <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3"></v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3"></v-col>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-row v-if="mostrarDatosProyectoDocumento">
              <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
                Formato: {{ this.value.dataFormato.value.descripcion }}</v-col
              >
              <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
                Proyecto: {{ this.value.dataProyecto.value.descripcion }}</v-col
              >
              <v-col :cols="12" :sm="12" :md="4" :lg="4" :xl="4">
                Documento: {{ this.value.dataDocumento.value.descripcion }}
              </v-col>
            </v-row>
          </v-col>
          <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3"></v-col>
        </v-row>
      </div>
    </v-card>
  </div>
</template>

<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
import ListaCecoComponente from "../componentes/ListaCecoComponente.vue";

export default {
  name: "BusquedaSucursalActualiza",
  components: {
    ListaCecoComponente,
  },
  created() {},
  data() {
    return {
      mostrarDatosProyectoDocumento: false,
    };
  },
  props: {
    value: Object,
    callbackCecoSeleccionado: { type: Function },
    borradoPorNivel: { type: Function },
  },
  methods: {
    reset() {
      this.borrarDatosProyecto();
      this.value.dataCeco.ceco = "";
      this.value.dataCeco.value = "";
      this.$refs.listaCecoComponente.reset();
    },
    borrarDatosProyecto() {
      this.mostrarDatosProyectoDocumento = false;
      this.value.dataFormato.value.descripcion = "";
      this.value.dataFormato.value.idFormato = 0;
      this.value.dataProyecto.value.descripcion = "";
      this.value.dataProyecto.value.idProyecto = 0;
      this.value.dataDocumento.value.descripcion = "";
      this.value.dataDocumento.value.idDocumento = 0;
      this.value.folio.idFolio = 0;
    },
    borradoPorNivelComponent(nivel) {
      this.borrarDatosProyecto();
      this.borradoPorNivel(nivel);
    },
    callbackCecoSeleccionadoComponent() {
      this.borrarDatosProyecto();
      this.cargarNegocio();
      this.consumeServicioDetalle();
    },
    cargarNegocio() {
      var prefijo = ("" + this.value.dataCeco.ceco).substr(0, 2);
      var idNegocio = 0;
      switch (prefijo) {
        case "92": //EKT
          idNegocio = 1;
          break;
        case "48": //BAZ
          idNegocio = 2;
          break;
        case "23": //OCC
          idNegocio = 3;
          break;
        case "62": //PP
          idNegocio = 4;
          break;
        case "67": //ITK
          idNegocio = 5;
          break;
        default:
          idNegocio = 0;
          break;
      }
      this.value.idNegocio = idNegocio;
    },
    setDatosInfo(info) {
      if (info.idFormato && info.idProyecto && info.idDocumento) {
        this.value.dataFormato.value.descripcion = info.nombreFormato;
        this.value.dataFormato.value.idFormato = info.idFormato;
        this.value.dataProyecto.value.descripcion = info.nombreProyecto;
        this.value.dataProyecto.value.idProyecto = info.idProyecto;
        this.value.dataDocumento.value.descripcion = info.nombreDocumento;
        this.value.dataDocumento.value.idDocumento = info.idDocumento;
        this.value.folio.idFolio = info.idFolio;
        this.mostrarDatosProyectoDocumento = true;
        this.callbackCecoSeleccionado(true);
      } else {
        this.callbackCecoSeleccionado(false);
      }
    },
    consumeServicioDetalle() {
      var ceco = this.value.dataCeco.ceco;
      if (typeof ceco == "string") {
        ceco = parseInt(ceco);
      }
      var body = {
        idCeco: ceco,
      };
      axios
        .post("/documento-sucursal/dato-zona/v1/protoyecto/ceco/", body)
        .then((response) => {
          let data = response.data;
          console.log("consumeServicioDetalle==>" + JSON.stringify(response.data));
          if (data && data.resultado) {
            let info = data.resultado[data.resultado.length - 1];
            this.setDatosInfo(info);
          } else {
            this.callbackCecoSeleccionado(false);
          }
        })
        .catch((error) => {
          if (error.response) {
            this.callbackCecoSeleccionado(false);
          }
        });
    },
  },
};
</script>

<style lang="scss" scoped></style>
